import React, { useRef, useMemo, useEffect, useState, useContext, createContext } from 'react'
import { ConfigProvider, message } from 'antd'
import Generator, { } from 'fr-generator'
import { settings, baseSettings, globalSettings } from './config'
import widgets from '../widgets'
import { saveTableConfig, GetTableConfigJson } from '../../apis/process'

export const GlobalStore = createContext(null)

const FormDesigner = (props) => {

  const { tableName } = props

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const pandaXform = getPrefixCls()

  const [table, setTable] = useState()
  const ref = useRef(null)

  const getTableField = () => {

  }

  const getTableInfo = () => {

  }

  const getTable = () => {

  }

  const getTableConfig = async () => {
    const { code, data } = await GetTableConfigJson({ tableName: '事件_测试02' })
    if (code === 0) {
      console.log(ref, data)
      if (typeof data === 'string') {
        setTimeout(() => {
          ref && ref.current && ref.current.setValue && ref.current.setValue(JSON.parse(data))
        }, 1000)
      }
    } else {
      message.error('获取表单配置失败')
    }
  }

  useEffect(() => {
    getTableConfig()
  }, [])

  const extraButtons = [
    {
      text: '提交',
      onClick: async (value) => {
        const errors = ref.current.getErrorFields()
        props.setSchema(ref.current.getValue())
        if (errors.length) {
          return message.error('请按照提示完善表单内容')
        }
        const { code, data, msg } = await saveTableConfig(ref.current.getValue())
        if (code === 0) {
          message.info('保存成功')
        } else {
          message.error(msg)
        }
      }
    }
  ]

  const getId = (value) => {
    // console.log('value', value)
    return value
  }

  const onChange = (value) => {
    // console.log('value', value)
  }

  const onSchemaChange = (value) => {
    // console.log('value', value)
    return value
  }

  const onCanvasSelect = (schema) => {
    // setWidget(schema.widget)
    // console.log('value', value)
  }

  return (
    <GlobalStore.Provider
      value={{
        tableName: '123'
      }}
    >
      <div className={prefixCls}>
        <Generator
          configProvider={{ prefixCls: pandaXform }}
          mapping={{
            object: 'Header',
          }}
          validation={true}
          ref={ref}
          extraButtons={extraButtons}
          onChange={onChange}
          onSchemaChange={onSchemaChange}
          widgets={widgets}
          onCanvasSelect={onCanvasSelect}
          settings={settings}
          commonSettings={baseSettings}
          globalSettings={globalSettings}
        />
      </div>
    </GlobalStore.Provider>
  )

}

export default FormDesigner