import React, { useMemo } from 'react'
import { TimePicker } from 'antd'
import moment from 'moment'
import style from '../../style'

const Time = ({ value, onChange, schema }) => {

  const { presetValue } = schema

  const valueShow = useMemo(() => {
    return (value || presetValue) ? moment(value || presetValue, 'HH:mm:ss') : null
  }, [presetValue, value])

  const timeChange = (time, timeStr) => {
    onChange(timeStr)
  }

  console.log('valueShow', valueShow)

  return (
    <TimePicker style={style} value={valueShow} onChange={timeChange} />
  )

}

export default Time