// 自定义复选框
import React, { useState, useEffect } from 'react';
import { Select } from 'antd';

const { Option } = Select;

const MultiSelect = ({ value, onChange, schema }) => {

  const { disabled, placeholder } = schema

  const children = [];
  for (let i = 0; i < schema.enum.length; i++) {
    children.push(<Option key={schema.enum[i]}>{schema.enum[i]}</Option>);
  }
  const val = value || schema.default;
  useEffect(() => {
    onChange(val);
  }, []);
  return (
    <Select
      disabled={disabled}
      showArrow={!disabled}
      mode={'multiple'}
      value={value ? value.split(',') : []}
      onChange={val => onChange(val.join(','))}
      style={{ width: '100%' }}
      placeholder={placeholder}
      tokenSeparators={[',']}
    >
      {children}
    </Select>
  );
};

export default MultiSelect;
