import React, { useMemo } from 'react'
import { InputNumber } from 'antd'
import style from '../../style'

const NumberInput = ({ value, onChange, schema }) => {

  const { disabled, presetValue, placeholder } = schema

  const valueShow = useMemo(() => {
    return presetValue || value
  }, [presetValue, value])

  return (
    <InputNumber
      placeholder={placeholder}
      disabled={disabled}
      value={valueShow}
      onChange={value => onChange(value)}
      style={style}
    />
  )

}

export default NumberInput