import React, { useState, useEffect, useMemo } from 'react'
import { Input } from 'antd'
import { StarFilled } from '@ant-design/icons'
import IconPack from '../../IconPack'

const SelfInfo = ({ value, onChange, schema }) => {

  const { disabled, placeholder, presetValue } = schema

  const addonAfter = useMemo(() => {
    if (schema.title === '本人部门') {
      return <StarFilled />
    } else if (schema.title === '本人姓名') {
      return <IconPack.User />
    } else if (schema.title === '本人ID') {
      return <IconPack.User />
    }
    return null
  }, [schema])

  const handleChange = (e) => {
    setInitValue(e.target.value)
    onChange(e.target.value)
  }

  // useEffect(() => {
  //   const val = value || schema.default
  //   setInitValue(val)
  //   onChange(val)
  // }, [])

  return (
    <Input
      disabled={disabled}
      value={presetValue}
      placeholder={placeholder}
      addonAfter={disabled ? null : addonAfter}
      onChange={handleChange}
    />
  )

}

export default SelfInfo
